<?php
namespace Teknisa\CMP\Modules\Fornecimento\Modules\AutorizacaoFornecimento\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\GER\Utilities\Environment;
use Teknisa\GER\Services\NewCode;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class CMP07200AlteracaoAutomaticaDeSituacaoDaAF {

    protected $dataSourceName = "cmp07200_alteracao_automatica_de_situacao_da_af_grid";

    protected $environment;
	protected $dataSourceManager;
	protected $newCode;
	protected $connection;
    protected $Cmp07200AlteracaoAutomaticaDeSituacaoDaAFService;

    public function __construct(Environment $environment, \Doctrine\ORM\EntityManager $entityManager ,$dataSourceManager, NewCode $newCode, $connection, $Cmp07200AlteracaoAutomaticaDeSituacaoDaAFService){
		$this->environment = $environment;
        $this->entityManager = $entityManager;
		$this->dataSourceManager = $dataSourceManager;
        $this->newCode = $newCode;
        $this->connection = $connection;
        $this->Cmp07200AlteracaoAutomaticaDeSituacaoDaAFService = $Cmp07200AlteracaoAutomaticaDeSituacaoDaAFService;
	}
	
	public function baixar(DTO\Request $request, DTO\Response $response) {
			
        $rows = $request->getDataSet()->getRows();
        $chave = '';
        
        foreach($rows as $row) {
            if($chave !== (string)$row['CDFILDEST']+(string)$row['CDFILLANC']+(string)$row['NRAUTOFORN']){
                $chave = $row['CDFILDEST']+$row['CDFILLANC']+$row['NRAUTOFORN'];
                $params = array(
                    'P_CDFILDEST'       => $row['CDFILDEST'],
    			    'P_CDFILLANC'       => $row['CDFILLANC'],
    			    'P_NRAUTOFORN'      => $row['NRAUTOFORN'],
    			    'P_CDPRODUTO'       => $row['CDPRODUTO'],
    			    'P_CDMARCA'         => $row['CDMARCA'],
    			    'P_DTPROGENTAF'     => $row['DT']
    			 
                );
                $query  = "SELECT A.CDFILDEST, A.CDFILLANC, A.NRAUTOFORN, A.IDBAIXAAF, I.CDPRODUTO, I.CDMARCA, A.CDFORNECED, I.DTPROGENTAF, TO_CHAR(SYSDATE, 'DD/MM/YYYY') DTATUAL FROM AUTOFORNE A, ITEMAUTF I WHERE A.CDFILDEST = :P_CDFILDEST AND A.CDFILLANC = :P_CDFILLANC AND A.NRAUTOFORN = :P_NRAUTOFORN AND I.CDPRODUTO = :P_CDPRODUTO AND I.CDMARCA = :P_CDMARCA AND I.DTPROGENTAF = :P_DTPROGENTAF AND A.CDFILDEST = I.CDFILDEST AND A.CDFILLANC = I.CDFILLANC AND A.NRAUTOFORN = I.NRAUTOFORN AND (NVL(I.IDITMSEPARADO, 'N') = 'N')";
                $stmt   = $this->connection->prepare($query);
                $stmt->execute($params);
                $result = $stmt->fetchAll();
            
                $cdfildest      = $result[0]['CDFILDEST']; 
                $cdfillanc      = $result[0]['CDFILLANC']; 
                $cdforneced     = $result[0]['CDFORNECED'];
                $dtprogentaf    = $result[0]['DTPROGENTAF'];
                $newdt          = $result[0]['DTATUAL'];
                $nrautoforn     = $result[0]['NRAUTOFORN'];
                $cdproduto      = $result[0]['CDPRODUTO'];
                $cdmarca        = $result[0]['CDMARCA'];
                $nrseqapuraf    = null;
    
                $this->Cmp07200AlteracaoAutomaticaDeSituacaoDaAFService->CARREGA_PERIFORN($cdfildest, $cdforneced, $dtprogentaf, $newdt);
    		    
    		    $totalitem = 0;
    		    foreach ($result as $return) {
    		        $params = array(
                        'P_CDFILDEST'       => $return['CDFILDEST'],
    			        'P_CDFILLANC'       => $return['CDFILLANC'],
    			        'P_NRAUTOFORN'      => $return['NRAUTOFORN'],
    			        'P_CDPRODUTO'       => $return['CDPRODUTO'],
    			        'P_CDMARCA'         => $return['CDMARCA'],
    			        'P_DTPROGENTAF'     => $return['DTPROGENTAF'],
    			        'P_IDBAIXITMAF'     => '3'
                    );
                    $query = "UPDATE ITEMAUTF SET IDBAIXITMAF = :P_IDBAIXITMAF WHERE CDFILDEST = :P_CDFILDEST AND CDFILLANC = :P_CDFILLANC AND NRAUTOFORN = :P_NRAUTOFORN AND CDPRODUTO = :P_CDPRODUTO AND CDMARCA = :P_CDMARCA AND DTPROGENTAF = :P_DTPROGENTAF";
                    $stmt = $this->connection->prepare($query);
                    $stmt->execute($params);
                    $totalitem++;
    		    }
    
    		    $params = array(
                    'P_CDFILDEST'       => $cdfildest,
    			    'P_CDFILLANC'       => $cdfillanc,
    			    'P_NRAUTOFORN'      => $nrautoforn,
                );
                
                $query  = "SELECT COUNT(*) AS TOTAL FROM ITEMAUTF WHERE CDFILDEST = :P_CDFILDEST AND CDFILLANC = :P_CDFILLANC AND NRAUTOFORN = :P_NRAUTOFORN";
                $stmt   = $this->connection->prepare($query);
                $stmt->execute($params);
                $totalbaixa = $stmt->fetchAll();
    		    $totalbaixa = $totalbaixa[0]['TOTAL'];
    		    
                $params = array(
                    'P_CDFILDEST'       => $cdfildest,
    			    'P_CDFILLANC'       => $cdfillanc,
    			    'P_NRAUTOFORN'      => $nrautoforn,
    			    'P_TOTALITEM'       => $totalitem,
    			    'P_TOTALBAIXA'      => $totalbaixa
                );
                
                $query  = "UPDATE AUTOFORNE SET IDBAIXAAF = DECODE(:P_TOTALITEM, :P_TOTALBAIXA, '3', '1') WHERE CDFILDEST = :P_CDFILDEST AND CDFILLANC = :P_CDFILLANC AND NRAUTOFORN = :P_NRAUTOFORN";
                $stmt   = $this->connection->prepare($query);
                $stmt->execute($params);
    		    $this->Cmp07200AlteracaoAutomaticaDeSituacaoDaAFService->AJUSTE_CONTPREVISTA($cdfildest, $cdfillanc, $nrautoforn);
            }
        }
    }
	
	public function cancelarEncerrar(DTO\Request $request, DTO\Response $response) {
			
        $rows = $request->getDataSet()->getRows();
        foreach($rows as $row) {
             
            $cdfildest      = $row['CDFILDEST'];
            $cdfillanc      = $row['CDFILLANC'];
            $nrautoforn     = $row['NRAUTOFORN'];
            $totalbaixa     = null;
            $totalitem      = null;
            $idbaixaaf      = $row['IDBAIXAAF'];
            $nrseqapuraf    = null;
            
            $params = array(
                'P_CDFILDEST'       => $cdfildest,
			    'P_CDFILLANC'       => $cdfillanc,
			    'P_NRAUTOFORN'      => $nrautoforn,
                'P_TOTALITEM'       => $totalitem,
			    'P_TOTALBAIXA'      => $totalbaixa,
			    'P_IDBAIXAAF'       => $idbaixaaf
			 
            );
            
            $query  = "UPDATE AUTOFORNE SET IDBAIXAAF = DECODE(:P_TOTALITEM, :P_TOTALBAIXA, :P_IDBAIXAAF, '1') WHERE CDFILDEST = :P_CDFILDEST AND CDFILLANC = :P_CDFILLANC AND NRAUTOFORN = :P_NRAUTOFORN";
            $stmt   = $this->connection->prepare($query);
            $stmt->execute($params);
            
		    $this->Cmp07200AlteracaoAutomaticaDeSituacaoDaAFService->AJUSTE_CONTPREVISTA($cdfildest, $cdfillanc, $nrautoforn);
		    
		    $params = array(
                'P_CDFILDEST'       => $cdfildest,
			    'P_CDFILLANC'       => $cdfillanc,
			    'P_NRAUTOFORN'      => $nrautoforn
            );
            
            $query  = "UPDATE AUTOFORNE SET CDTPCTPAGAR = (SELECT PRODUTO.CDTPCTPAGAR FROM PRODUTO, (SELECT MAX(PRODUTO.CDARVPROD) AS CDARVPROD FROM PRODUTO, (SELECT MIN(A.CDARVPROD) AS CDARVPROD FROM (SELECT CDARVPROD, MAX(QTPROGENTAF*VRPREUNIAF) FROM ITEMAUTF, PRODUTO P WHERE P.CDPRODUTO = ITEMAUTF.CDPRODUTO AND ITEMAUTF.CDFILDEST = :P_CDFILDEST AND ITEMAUTF.CDFILLANC = :P_CDFILLANC AND ITEMAUTF.NRAUTOFORN = :P_NRAUTOFORN GROUP BY CDARVPROD HAVING MAX(QTPROGENTAF*VRPREUNIAF) = (SELECT MAX(QTPROGENTAF*VRPREUNIAF) FROM ITEMAUTF WHERE ITEMAUTF.CDFILDEST = :P_CDFILDEST AND ITEMAUTF.CDFILLANC = :P_CDFILLANC AND ITEMAUTF.NRAUTOFORN = :P_NRAUTOFORN))A) ITEMAUTF WHERE ITEMAUTF.CDARVPROD LIKE PRODUTO.CDARVPROD || '%' AND PRODUTO.CDTPCTPAGAR IS NOT NULL) TIPOCTPAGAR WHERE PRODUTO.CDARVPROD = TIPOCTPAGAR.CDARVPROD AND PRODUTO.CDTPCTPAGAR IS NOT NULL) WHERE AUTOFORNE.CDFILDEST = :P_CDFILDEST AND AUTOFORNE.CDFILLANC = :P_CDFILLANC AND AUTOFORNE.NRAUTOFORN = :P_NRAUTOFORN AND AUTOFORNE.CDTPCTPAGAR IS NULL";
            $stmt   = $this->connection->prepare($query);
            $stmt->execute($params);
            
            $this->Cmp07200AlteracaoAutomaticaDeSituacaoDaAFService->CUSTO_AF($cdfildest, $cdfillanc, $nrautoforn, $nrseqapuraf);
            
            $params = array(
                'P_CDFILDEST'       => $cdfildest,
			    'P_CDFILLANC'       => $cdfillanc,
			    'P_NRAUTOFORN'      => $nrautoforn
            );
            
            $query  = "SELECT F.IDGERCONTPGT FROM FORNECEDOR F, AUTOFORNE A WHERE A.CDFILDEST = :P_CDFILDEST AND A.CDFILLANC = :P_CDFILLANC AND A.NRAUTOFORN = :P_NRAUTOFORN AND A.CDFORNECED = F.CDFORNECED";
            $stmt   = $this->connection->prepare($query);
            $stmt->execute($params);
        
        }
    }
    
    public function setgrid(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $NRLISTA = $this->newCode->getCodeByTableName('LISTA', $this->environment->getNrorgTrab(), 1, 10, false);

        if($row['UNIDADE']== 'T'){
            if($row['AGRUPAMENTO']== 'T'){
                $this ->acmTodasFiliais($NRLISTA);
            }
            else{
                $this ->acmTodasFilAgrup($NRLISTA, $row['AGRUPAMENTO']);
            }
        }
        else{
            $filiais = array();
            $filiais = $row['UNIDADE'];
            $filiais = explode("_", $row['UNIDADE']);
            foreach($filiais as $filial) {
                $this ->insertLista($NRLISTA, $filial);
            }
        }
        
        $value = array($NRLISTA);
        
        $response->addDataSet(new DataSet("NrLista", $value));
    }
    
    public function insertLista($nrlista, $cdlista) {
        $params = array(
    		"NRLISTA" => $nrlista,
    		"CDLISTA" => $cdlista
    	);
    	
    	$sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";
    	$query = $this->connection->prepare($sql);
    	$query->execute($params);
         
     }
     
    public function acmTodasFiliais($nrlista) {
        $params = array(
    		"NRLISTA" => $nrlista
    	);
    	$sql = "INSERT INTO LISTA(NRLISTA, CDLISTA) (SELECT :NRLISTA, CDFILIAL FROM FILIAL WHERE EXISTS(SELECT 1 FROM SOLICITA WHERE CDFILSOLI = CDFILIAL))";
    	$query = $this->connection->prepare($sql);
    	$query->execute($params);
         
    }
    
    public function acmTodasFilAgrup($nrlista, $cdgrupfili) {
        $params = array(
    		"NRLISTA" => $nrlista,
    		"P_CDGRUPFILI" => $cdgrupfili
    	);
    	
    	$sql = "INSERT INTO LISTA(NRLISTA, CDLISTA) (SELECT :NRLISTA, CDFILIAL FROM FILGRUPFILI WHERE CDGRUPFILI = :P_CDGRUPFILI) ";
    	$query = $this->connection->prepare($sql);
    	$query->execute($params);

         
     }
}