<?php
namespace Teknisa\CMP\Modules\NecessidadeCompras\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Cmp03800PreviaDoCalculoDaNecessidadeDeComprasRelat extends \Zeedhi\Framework\Controller\Report
{
    protected $entityManager;
    protected $birtStrategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;

    public function __construct($reportService, $entityManager, $reportStrategies, $newCode, $environment, $connection, $dataSourceManager)
    {
        $this->entityManager     = $entityManager;
        $this->reportStrategies  = $reportStrategies;
        $this->reportService     = $reportService;
        $this->newCode           = $newCode;
        $this->environment       = $environment;
        $this->connection        = $connection;
        $this->dataSourceManager = $dataSourceManager;
    }
   
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $row["DATAINI1"] = $row["DATAINI"];
        $row["DATAFIN1"] = $row["DATAFIN"];
        
        $this->reportStrategy = $this->getStrategyByName($row['STRATEGY']);
        
        if ($row['STRATEGY'] == 'BIRT') {
            $this->reportStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        } else {
            $this->reportStrategy->setQr2Type($row['QR2TYPE']);
        }
        
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] = 
            array(
                    'strategy' => $row['STRATEGY'],
                    'parameterMapping'  => array(
                        "NRORG"         => "P_NRORG",
                        "NRNECECOMP"    => "P_NRNECECOMP",
                        "CDFILIAL"      => "P_CDFILIAL",
                        "DATAINI"       => "P_DATAINI",
                        "DATAFIN"       => "P_DATAFIN",
                        "FILIPROC"      => "P_FILIPROC",
                        "DATAINI1"      => "P_DATAINI1",
                        "DATAFIN1"      => "P_DATAFIN1"
                    ),
            );
    }
    
    /**
     * @param $strategyName
     * @return Strategy\ReportStrategy
     * @throws Exception
     */
	protected function getStrategyByName($strategyName) {
		foreach ($this->reportStrategies as $reportStrategy) {
			if ($reportStrategy->getName() == $strategyName) {
				return $reportStrategy;
			}
		}
		throw Exception::strategyNotFound($strategyName);
	}
}
